"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var graphql_1 = require("graphql");
var TypeScriptSelectionSetToObject = /** @class */ (function (_super) {
    __extends(TypeScriptSelectionSetToObject, _super);
    function TypeScriptSelectionSetToObject(_scalars, _schema, _convertName, _addTypename, _parentSchemaType, _selectionSet) {
        return _super.call(this, _scalars, _schema, _convertName, _addTypename, _parentSchemaType, _selectionSet) || this;
    }
    TypeScriptSelectionSetToObject.prototype.createNext = function (parentSchemaType, selectionSet) {
        return new TypeScriptSelectionSetToObject(this._scalars, this._schema, this._convertName, this._addTypename, parentSchemaType, selectionSet);
    };
    TypeScriptSelectionSetToObject.prototype.clearOptional = function (str) {
        if (str.startsWith('Maybe')) {
            return str.replace(/^Maybe<(.*?)>$/i, '$1');
        }
        return str;
    };
    TypeScriptSelectionSetToObject.prototype.wrapTypeWithModifiers = function (baseType, type) {
        if (graphql_1.isNonNullType(type)) {
            return this.clearOptional(this.wrapTypeWithModifiers(baseType, type.ofType));
        }
        else if (graphql_1.isListType(type)) {
            var innerType = this.wrapTypeWithModifiers(baseType, type.ofType);
            return "Maybe<Array<" + innerType + ">>";
        }
        else {
            return "Maybe<" + baseType + ">";
        }
    };
    return TypeScriptSelectionSetToObject;
}(graphql_codegen_visitor_plugin_common_1.SelectionSetToObject));
exports.TypeScriptSelectionSetToObject = TypeScriptSelectionSetToObject;
//# sourceMappingURL=ts-selection-set-to-object.js.map